#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<ctime>
#include "pieces.h"
#include "structures.h"
#include "SDL/SDL.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_mixer.h"
#include "definesurfaces.h"
#include "functions.h"
#include "initialiser.h"
#include "destructor.h"
#include "oneplayergame.h"
#include "twoplayergame.h"
#include "playgame.h"
#include "apply_instructions.h"
#include "instructionpage.h"
#include "apply_credits.h"
using namespace std;

 FILE* hscore;

int main ( int argc, char*argv[] )
{
     hsc=0;//dddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddd
                                        hscore = fopen( "high_score.txt", "r" );

                                           fscanf(hscore,"%d",&hsc);
init    ( );
while   ( !gamequit )
    {

        if ( SDL_PollEvent( &event ) )
            {
                apply_surface (   0,   0, menu_background,    screen );
                apply_surface (   0,   0,           title,    screen );
                apply_surface ( 260, 200,         playnow,    screen );
                apply_surface ( 170, 260,    instructions,    screen );
                apply_surface ( 224, 320,          credit,    screen );
                apply_surface ( 273, 380,      quitbutton,    screen );

                switch ( cursor )
                    {
                        case 0: apply_surface ( 220, 201, pointer, screen );  break;
                        case 1: apply_surface ( 130, 261, pointer, screen );  break;
                        case 2: apply_surface ( 184, 321, pointer, screen );  break;
                        case 3: apply_surface ( 233, 381, pointer, screen );  break;
                    }

                SDL_Flip  ( screen );
                SDL_Delay (   10   );

                if ( event.type == SDL_QUIT)
                    {
                        gamequit=true;
                    }

                if( event.type == SDL_KEYDOWN )
                    {
                        switch  ( event.key.keysym.sym )
                            {
                                case SDLK_DOWN:     cursor+=1;      cursor%=4; Mix_PlayChannel( -1, smenu, 0 );   break;
                                case SDLK_UP:       cursor+=3;      cursor%=4; Mix_PlayChannel( -1, smenu, 0 );   break;
                                case SDLK_m:        pause_music ( );                                              break;
                                case SDLK_RETURN:   cursor%=4;

                                switch  ( cursor )
                                    {
                                        case 0: playgame            ( hsc);            break;
                                        case 1: displayinstructions  ( );            break;
                                        case 2: apply_credits       ( );            break;
                                        case 3: clean_up            ( );    gamequit=true;
                                    }
                            }
                    }
            }
        quit=0;
    }
return 0;
}
