void apply_surface( int x, int y, SDL_Surface* source, SDL_Surface* destination )
{
    //Make a temporary rectangle to hold the offsets
    SDL_Rect offset;
    //Give the offsets to the rectangle
    offset.x = x;
    offset.y = y;
    //Blit the surface
    SDL_BlitSurface( source, NULL, destination, &offset );
}

void printscore( int x, int xc, int yc )
{
    SDL_Color textColor = { 255, 255, 255 };
    char  s[100];
    sprintf ( s, "SCORE\t%d", x );
    score=TTF_RenderText_Solid ( font, s, textColor );
    apply_surface (  xc, yc, score, screen ); //40,100
    SDL_Flip ( screen );
}

void printline(int x, int xc, int yc,int &hsc )
{
    SDL_Color textColor = { 255, 255, 255 };
    char  s[100];
    sprintf ( s, "LINE\t%d", x );
    lines = TTF_RenderText_Solid ( font, s, textColor );
    apply_surface ( xc, yc, lines, screen ); //480, 100
    if(csc>hsc) hsc=csc;
    sprintf ( s, "High score\n" );
    lines = TTF_RenderText_Solid ( font, s, textColor );
    apply_surface ( 425, 300, lines, screen );
    sprintf ( s, "%d" ,hsc);
    lines = TTF_RenderText_Solid ( font, s, textColor );
    apply_surface ( 425, 330, lines, screen );
    SDL_Flip ( screen );
}

void printlevel( int x, int xc, int yc )
{
    SDL_Color textColor = { 255, 255, 255 };
    char  s[100];
    sprintf ( s, "LEVEL\t%d", x );
    level = TTF_RenderText_Solid( font, s, textColor );
    apply_surface ( xc, yc, level, screen ); //480, 140
    SDL_Flip ( screen );
}

void drawboard ( Board b1, int xc )
{
    for( int i=0; i<24; i++ )
        {
            for ( int j=0; j<14; j++ )
                {
                    switch ( b1.board[i][j] )
                    {
                        case 0: apply_surface   ( xc+20*j, 20*i,   GRID, screen ); break;
                        case 1: apply_surface   ( xc+20*j, 20*i,    RED, screen ); break;
                        case 2: apply_surface   ( xc+20*j, 20*i,   BLUE, screen ); break;
                        case 3: apply_surface   ( xc+20*j, 20*i, YELLOW, screen ); break;
                        case 4: apply_surface   ( xc+20*j, 20*i,  GREEN, screen ); break;
                        case 5: apply_surface   ( xc+20*j, 20*i, ORANGE, screen ); break;
                        case 6: apply_surface   ( xc+20*j, 20*i, PURPLE, screen ); break;
                        case 7: apply_surface   ( xc+20*j, 20*i,  DBLUE, screen ); break;
                    }
                }
        }
}

void drawpiece ( SDL_Surface* x, block p1, int piece[][4][4][4] )
{

    for( int i = 0; i < 4; i++ )
    {
        for ( int j = 0; j < 4; j++ )
            {
                apply_surface( 20*j, 20*i, TRANSPARENT, x );
            }
    }

    for( int i = 0; i < 4; i++ )
    {
        for ( int j = 0; j < 4; j++ )
        {
            switch ( piece[p1.t][p1.o][i][j] )
            {
                case 10: apply_surface  ( 20*j, 20*i,    RED, x );  break;
                case 20: apply_surface  ( 20*j, 20*i,   BLUE, x );  break;
                case 30: apply_surface  ( 20*j, 20*i, YELLOW, x );  break;
                case 40: apply_surface  ( 20*j, 20*i,  GREEN, x );  break;
                case 50: apply_surface  ( 20*j, 20*i, ORANGE, x );  break;
                case 60: apply_surface  ( 20*j, 20*i, PURPLE, x );  break;
                case 70: apply_surface  ( 20*j, 20*i,  DBLUE, x );  break;
            }
        }
    }
}

void gameover()
{
   int hsc;
    FILE* hscore;//
    hscore = fopen( "high_score.txt", "r" );
    fscanf(hscore,"%d",&hsc);
    SDL_Color textColor = { 255, 255, 255 };
    char  s[100];


    if( hscore != NULL )
        {
            fscanf ( hscore, "%d", &hsc ) ;
            fclose(hscore);
            hscore = fopen( "high_score.txt", "w+" );

            if ( hsc < csc )
                {
                    hsc = csc;//


                }
                    fprintf ( hscore, "%d", hsc );
            fclose ( hscore );
        }
        if(csc=hsc)
        {

                        apply_surface   ( 220,   0, deathscreen, screen );//f
                            Mix_HaltMusic   ( );
                            Mix_PlayChannel ( -1, sgameover, 0 );
                            apply_surface ( 230, 350, high, screen );
                            apply_surface ( 425, 330, lines, screen );//

                            SDL_Flip        ( screen );

                            SDL_Delay       (  2000  );
                            quit=true;
        }
        else{
    apply_surface   ( 220,   0, deathscreen, screen );//
    Mix_HaltMusic   ( );
    Mix_PlayChannel ( -1, sgameover, 0 );
    SDL_Flip        ( screen );
    SDL_Delay       (  2000  );
    quit=true;
}
}

void printblocktoboard( block p1, int piece[][4][4][4], Board &b1 )
{
    for ( int i = 0; i < 4; i++ )
    {
        for ( int j = 0; j < 4; j++ )
            {
                b1.board[p1.y+i][p1.x+j] += ( (piece[p1.t][p1.o][i][j]) / 10 );
            }
    }
}

int collision_detect( block &p1, int piece[][4][4][4], Board b1 )
{
     int z = 0;
     for ( int i = 0; i < 4; i++ )
        {
            for ( int j = 0; j < 4; j++)
            {
                z = b1.board[p1.y+i][p1.x+j];
                //cout<<z;
                if ( z > 0 )
                    {
                        if ( piece[p1.t][p1.o][i][j] > 0 ) return 0;
                    }
            }
        }
    return 1;
}

void moveright( block &p1, int piece[][4][4][4], Board b1 )
{
    p1.moveright ( );
    if ( collision_detect ( p1, piece, b1 ) == 0 )
        {
            p1.moveleft ( );
        }
    else Mix_PlayChannel ( -1, smovement, 0 );
}

void moveleft( block &p1, int piece[][4][4][4], Board b1 )
{
    p1.moveleft ( );
    if ( collision_detect ( p1, piece, b1 ) == 0 )
        {
            p1.moveright ( );
        }
    else Mix_PlayChannel( -1, smovement, 0 );
}

void rotate1( block &p1, int piece[][4][4][4], Board b1 )
{
    p1.rotate1();
    if ( collision_detect ( p1, piece, b1 ) == 0 )
        {
            p1.rotate2 ( );
        }
}

void rotate2( block &p1, int piece[][4][4][4], Board b1 )
{
    p1.rotate2 ( );
    if ( collision_detect ( p1, piece, b1 ) == 0)
        {
            p1.rotate1 ( );
        }
}

void printghosttoboard( SDL_Surface* x, block p1, int piece[][4][4][4] )
{
     for( int i = 0; i < 4; i++ )
    {
        for( int j = 0; j < 4; j++ )
        {
            apply_surface( 20*j, 20*i, TRANSPARENT, x );
        }
    }

    for( int i = 0; i < 4; i++ )
    {
        for( int j = 0; j < 4; j++ )
        {
            if ( piece[p1.t][p1.o][i][j] != 0 ) apply_surface( 20*j, 20*i, GHOST, x );

        }
    }
}

void addghost(block &x, SDL_Surface* y, block p1, int piece[][4][4][4], Board b1 )
{
    x = p1;
    while( true ){
        x.movedown ( );
        if ( collision_detect ( x, piece, b1 ) == 0)
        {
            x.y--;
            printghosttoboard ( y, x, piece );
            break;
        }

}
}

void movedown(block &x, block &p1, SDL_Surface* y, block &p2, int piece[][4][4][4], Board &b1, Uint32 &start, bool &flag )
{
    int l;
    int l2;
    p1.movedown ( );
     if ( collision_detect ( p1, piece, b1 ) == 0)
        {
            p1.y--;
            printblocktoboard ( p1, piece, b1 );
            int l;
            l = b1.numvanishline;
            b1.detectline ( );
            l2 = b1.numvanishline;
            p1 = p2;
            p2.init ( );
            x = p1;
            addghost ( x, y, p1, piece, b1 );
            flag = false;
            csc = b1.score;
            if( collision_detect ( p1, piece, b1 ) == 0)
                {
                    gameover ( );
                }
            else
                {
                    if (l2!=l)
                        {
                            Mix_PlayChannel( -1, slinevanish, 0 );
                        }
                    else if(l2==l) Mix_PlayChannel(-1, sdrop, 0);
                }
        }

    else Mix_PlayChannel( -1, smovement, 0 );
    start=SDL_GetTicks();
}


void harddrop(block &x, SDL_Surface* y, block &p1, block &p2, int piece[][4][4][4], Board &b1, Uint32 &start, bool &flag )
{
    int l;
    int l2;
    while( true )
        {
            p1.movedown ( );
            if ( collision_detect ( p1, piece, b1 ) == 0)
                {
                    p1.y--;
                    printblocktoboard( p1, piece, b1 );
                    l = b1.numvanishline;
                    b1.detectline ( );
                    l2 = b1.numvanishline;
                    p1 = p2;
                    p2.init ( );
                    x = p1;
                    addghost( x, y, p1, piece, b1 );
                    flag = false;
                    csc = b1.score;
                    if( collision_detect ( p1, piece, b1 ) == 0) gameover ( );
                    else {
                            if ( l2 == l)
                                {
                                    Mix_PlayChannel( -1, sdrop, 0 );
                                }
                            else if( l2 != l ) Mix_PlayChannel( -1, slinevanish, 0 );
                         }
                    break;
                }


        }
start = SDL_GetTicks ( );
}

void swap_captured_block( block &p1, block &captured )
{
    block temp;
    temp = p1;
    p1 = captured;
    captured = temp;
    captured.y = 0;
    captured.x = 5;
}

void blockcapture( block &p1, block &p2, block &captured, Uint32 &start, bool &flag )
{
    if ( flag == false)
    {
        if ( captured.t == 9)
            {
                captured = p1;
                captured.y = 0;
                captured.x = 5;
                p1 = p2;
                p2.init ( );
                flag = true;
            }
        else
            {
                swap_captured_block ( p1, captured );
                flag = true;
            }

    start = SDL_GetTicks ( );

    }
}

void pause_music ( )
{
    if( Mix_PlayingMusic ( ) == 0 )
        {
            //Play the music
            Mix_PlayMusic(music, -1 );
        }
     else
        {
            //If the music is paused
            if( Mix_PausedMusic ( ) == 1 )
                {
                    //Resume the music
                    Mix_ResumeMusic ( );
                }
            //If the music is playing
            else
                {
                    //Pause the music
                    Mix_PauseMusic();
                }
        }

}
